// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from marti_common_msgs:msg/StringArrayStamped.idl
// generated code does not contain a copyright notice
#include "marti_common_msgs/msg/detail/string_array_stamped__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `strings`
#include "rosidl_runtime_c/string_functions.h"

bool
marti_common_msgs__msg__StringArrayStamped__init(marti_common_msgs__msg__StringArrayStamped * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    marti_common_msgs__msg__StringArrayStamped__fini(msg);
    return false;
  }
  // strings
  if (!rosidl_runtime_c__String__Sequence__init(&msg->strings, 0)) {
    marti_common_msgs__msg__StringArrayStamped__fini(msg);
    return false;
  }
  return true;
}

void
marti_common_msgs__msg__StringArrayStamped__fini(marti_common_msgs__msg__StringArrayStamped * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // strings
  rosidl_runtime_c__String__Sequence__fini(&msg->strings);
}

marti_common_msgs__msg__StringArrayStamped *
marti_common_msgs__msg__StringArrayStamped__create()
{
  marti_common_msgs__msg__StringArrayStamped * msg = (marti_common_msgs__msg__StringArrayStamped *)malloc(sizeof(marti_common_msgs__msg__StringArrayStamped));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(marti_common_msgs__msg__StringArrayStamped));
  bool success = marti_common_msgs__msg__StringArrayStamped__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
marti_common_msgs__msg__StringArrayStamped__destroy(marti_common_msgs__msg__StringArrayStamped * msg)
{
  if (msg) {
    marti_common_msgs__msg__StringArrayStamped__fini(msg);
  }
  free(msg);
}


bool
marti_common_msgs__msg__StringArrayStamped__Sequence__init(marti_common_msgs__msg__StringArrayStamped__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  marti_common_msgs__msg__StringArrayStamped * data = NULL;
  if (size) {
    data = (marti_common_msgs__msg__StringArrayStamped *)calloc(size, sizeof(marti_common_msgs__msg__StringArrayStamped));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = marti_common_msgs__msg__StringArrayStamped__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        marti_common_msgs__msg__StringArrayStamped__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
marti_common_msgs__msg__StringArrayStamped__Sequence__fini(marti_common_msgs__msg__StringArrayStamped__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      marti_common_msgs__msg__StringArrayStamped__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

marti_common_msgs__msg__StringArrayStamped__Sequence *
marti_common_msgs__msg__StringArrayStamped__Sequence__create(size_t size)
{
  marti_common_msgs__msg__StringArrayStamped__Sequence * array = (marti_common_msgs__msg__StringArrayStamped__Sequence *)malloc(sizeof(marti_common_msgs__msg__StringArrayStamped__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = marti_common_msgs__msg__StringArrayStamped__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
marti_common_msgs__msg__StringArrayStamped__Sequence__destroy(marti_common_msgs__msg__StringArrayStamped__Sequence * array)
{
  if (array) {
    marti_common_msgs__msg__StringArrayStamped__Sequence__fini(array);
  }
  free(array);
}
